diff -r df9e3cb79379 -r 1ccb99c08f27 libinterp/parse-tree/pt-jit.cc
--- a/libinterp/parse-tree/pt-jit.cc	Wed May 08 18:45:34 2019 -0700
+++ b/libinterp/parse-tree/pt-jit.cc	Fri May 31 16:09:22 2019 -0500
@@ -2159,12 +2165,12 @@
 
     llvm::ExecutionEngine *e = llvm::EngineBuilder (std::move (module_owner))
       .setErrorStr (&err)
-      .setMCJITMemoryManager(llvm::make_unique<jit_memory_manager> ())
+      .setMCJITMemoryManager (llvm::make_unique<jit_memory_manager> ())
       .create ();
 
     // Note: in some versions of LLVM, we should call .setUseMCJIT (true)
     // before .create () ?
-    // FIXME: autconf this
+    // FIXME: autoconf this
 
     if (e == nullptr)
       error ("failed to create JIT engine: %s", err.c_str ());
@@ -2173,37 +2179,37 @@
   }
 
   void
-  tree_jit::do_register_jit_module (jit_module* jm)
+  tree_jit::do_register_jit_module (jit_module *jm)
   {
     jm_list.push_back (jm);
   }
 
   void
-  tree_jit::do_unregister_jit_module (jit_module* jm)
+  tree_jit::do_unregister_jit_module (jit_module *jm)
   {
     jm_list.remove (jm);
   }
 
-  void*
-  tree_jit::do_getPointerToNamedFunction (const std::string &name) const
+  void *
+  tree_jit::do_getPointerToNamedFunction (const std::string& name) const
   {
-    std::list<jit_module*>::const_iterator it;
+    std::list<jit_module *>::const_iterator it;
 
     for (it = jm_list.begin (); it != jm_list.end (); it++)
       {
         uint64_t addr = (*it)->getFunctionAddress (name);
 
         if (addr)
-          return reinterpret_cast<void*> (addr);
+          return reinterpret_cast<void *> (addr);
       }
 
     return nullptr;
   }
 
   uint64_t
-  tree_jit::do_getSymbolAddress(const std::string &name) const
+  tree_jit::do_getSymbolAddress (const std::string& name) const
   {
-    std::list<jit_module*>::const_iterator it;
+    std::list<jit_module *>::const_iterator it;
 
     for (it = jm_list.begin (); it != jm_list.end (); it++)
       {
@@ -2251,7 +2257,6 @@
 
     jit::ModuleOwner m (new llvm::Module (module_name, context));
 
-
     if (m != nullptr)
       m->setDataLayout (target_machine->createDataLayout ());
 
@@ -2259,7 +2264,7 @@
   }
 
   bool
-  tree_jit::do_execute (tree_simple_for_command& cmd,
+  tree_jit::do_execute (tree_evaluator& tr_eval, tree_simple_for_command& cmd,
                         const octave_value& bounds)
   {
     size_t tc = trip_count (bounds);
@@ -2278,7 +2283,7 @@
 
         delete info;
 
-        info = new jit_info (cmd, bounds);
+        info = new jit_info (tr_eval, cmd, bounds);
 
         cmd.stash_info (info);
       }
@@ -2287,7 +2292,7 @@
   }
 
   bool
-  tree_jit::do_execute (tree_while_command& cmd)
+  tree_jit::do_execute (tree_evaluator& tr_eval, tree_while_command& cmd)
   {
     if (! initialized || ! enabled ())
       return false;
@@ -2296,7 +2301,7 @@
     if (! info || ! info->match ())
       {
         delete info;
-        info = new jit_info (cmd);
+        info = new jit_info (tr_eval, cmd);
         cmd.stash_info (info);
       }
 
@@ -2304,7 +2309,7 @@
   }
 
   bool
-  tree_jit::do_execute (octave_user_function& fcn,
+  tree_jit::do_execute (tree_evaluator& tr_eval, octave_user_function& fcn,
                         const octave_value_list& args,
                         octave_value_list& retval)
   {
@@ -2315,7 +2320,7 @@
     if (! info || ! info->match (args))
       {
         delete info;
-        info = new jit_function_info (fcn, args);
+        info = new jit_function_info (tr_eval, fcn, args);
         fcn.stash_info (info);
       }
 
@@ -2347,7 +2352,6 @@
     return 0;
   }
 
-
   // -------------------- jit_module --------------------
 
   jit_module::jit_module (const std::string& module_name)
@@ -2366,8 +2370,7 @@
     // TODO?: Consider creating the engine just before jitting
 
     // We take responsibility for deleting the engine
-    m_engine = engine_owner.get ();
-    engine_owner.release ();
+    m_engine = engine_owner.release ();
 
     tree_jit::register_jit_module (this);
   }
@@ -2380,11 +2383,11 @@
   }
 
   // Create an LLVM function in the module, with external linkage
-  llvm::Function*
+  llvm::Function *
   jit_module::create_llvm_function (llvm::FunctionType *ftype,
-                                    const llvm::Twine &name) const
+                                    const llvm::Twine& name) const
   {
-    // we mark all functinos as external linkage because this prevents
+    // we mark all functions as external linkage because this prevents
     // llvm from getting rid of always inline functions
 
     return llvm::Function::Create (ftype, llvm::Function::ExternalLinkage,
@@ -2393,16 +2396,16 @@
 
   // Create or insert an LLVM Function declaration for an intrinsic and return
   // it
-  llvm::Function*
+  llvm::Function *
   jit_module::get_intrinsic_declaration (size_t id,
-                                         std::vector<llvm::Type*> types) const
+                                         const std::vector<llvm::Type *>& types) const
   {
-    return llvm::Intrinsic::getDeclaration
-      (m_module, static_cast<llvm::Intrinsic::ID> (id), types);
+    return llvm::Intrinsic::getDeclaration (m_module,
+                                  static_cast<llvm::Intrinsic::ID> (id), types);
   }
 
   // Create a global in the module
-  llvm::GlobalVariable*
+  llvm::GlobalVariable *
   jit_module::create_global_variable (llvm::Type *type, bool is_constant,
                                       const llvm::Twine& name) const
   {
@@ -2412,7 +2415,7 @@
   }
 
   void
-  jit_module::do_add_global_mapping (const llvm::GlobalValue* gv, void* p) const
+  jit_module::do_add_global_mapping (const llvm::GlobalValue *gv, void *p) const
   {
     assert (gv);
     m_engine->addGlobalMapping (gv, p);
@@ -2420,11 +2423,17 @@
 
   // Return the address of the specified function.
   uint64_t
-  jit_module::getFunctionAddress (const std::string &name) const
+  jit_module::getFunctionAddress (const std::string& name) const
   {
     return m_engine->getFunctionAddress (name);
   }
 
+  llvm::Function *
+  jit_module::getFunction (const std::string& name) const
+  {
+    return m_module->getFunction (name);
+  }
+
   void
   jit_module::optimize (llvm::Function *fn) const
   {
@@ -2434,9 +2443,10 @@
     // DOCUMENT-ME: Why do we need two separate pass managers?
 
     jit::PassManager *module_pass_manager = new jit::PassManager ();
-    jit::FunctionPassManager *pass_manager = new jit::FunctionPassManager (m_module);
-
-#if defined (LLVM_HAS_CREATEALWAYSINLINERPASS)
+    jit::FunctionPassManager *pass_manager
+        = new jit::FunctionPassManager (m_module);
+
+#if defined(LLVM_HAS_CREATEALWAYSINLINERPASS)
     // This pass has been removed from LLVM's C++ API after 3.9.0
     // FIXME: Provide a meaningful replacement instead of simply skipping it?
     module_pass_manager->add (llvm::createAlwaysInlinerPass ());
@@ -2491,24 +2501,94 @@
         //#else
         //      llvm::raw_fd_ostream fout ("test.bc", error, llvm::raw_fd_ostream::F_Binary);
         //#endif
-
+#if defined(LLVM_WRITEBITCODETOFILE_HAS_PTR_ARG)
         llvm::WriteBitcodeToFile (m_module, fout);
+#else
+        llvm::WriteBitcodeToFile (*m_module, fout);
+#endif
       }
   }
 
   void
+  jit_module::print_object_summary (void)
+  {
+    octave_stdout << "---------------------------------------------\n";
+    octave_stdout << "Summary for " << m_module->getName ().str () << ":\n\n";
+    m_module->print (llvm::outs (), nullptr);
+    octave_stdout << std::endl;
+
+    std::string errstring;
+    llvm::raw_string_ostream ros (errstring);
+    if (llvm::verifyModule (*m_module, &ros))
+      {
+        octave_stdout << "Errors: \n\n";
+        octave_stdout << ros.str () << std::endl;
+      }
+    octave_stdout << "---------------------------------------------\n";
+  }
+
+  void
+  jit_module::print_all_flocs (void) const
+  {
+    octave_stdout << "ALL FUNCTION LOCATIONS FOR MODULE "
+                  << m_module->getName ().str () << '\n';
+    octave_stdout << "--------------------------------------------------------"
+                  << '\n';
+    for (const llvm::Function& f : *m_module)
+      {
+        octave_stdout << f.getName ().str () << ": ";
+        octave_stdout << std::hex << std::showbase << std::nouppercase
+                  << m_engine->getFunctionAddress (f.getName ());
+        octave_stdout << '\n';
+      }
+    octave_stdout << std::endl;
+  }
+
+  // TESTING
+  void
+  jit_module::print_all_functions () const
+  {
+    octave_stdout << "ALL FUNCTIONS FOR MODULE " << m_module->getName ().str ()
+                  << '\n';
+    octave_stdout << "--------------------------------------------------------"
+                  << '\n';
+    for (const llvm::Function& f : *m_module)
+      {
+        octave_stdout << "Location: ";
+        octave_stdout << std::hex << std::showbase << std::nouppercase
+                  << m_engine->getFunctionAddress (f.getName ());
+        octave_stdout.flush ();
+        f.print (llvm::outs ());
+        octave_stdout << '\n';
+      }
+    octave_stdout << "--------------------------------------------------------"
+                  << std::endl;
+  }
+
+  void
+  jit_module::dump () const
+  {
+    octave_stdout << "DUMP FOR MODULE " << m_module->getName ().str ()
+                  << '\n';
+    octave_stdout << "-------------------------------" << std::endl;
+    m_module->print (llvm::outs (), nullptr);
+    octave_stdout << "-------------------------------" << '\n';
+    octave_stdout << std::endl;
+  }
+
+  void
   jit_module::finalizeObject (void)
   {
+    // print_object_summary ();
     m_engine->finalizeObject ();
   }
 
-
   // -------------------- jit_function_info --------------------
-  jit_function_info::jit_function_info (octave_user_function& fcn,
+  jit_function_info::jit_function_info (tree_evaluator& tr_eval,
+                                        octave_user_function& fcn,
                                         const octave_value_list& ov_args)
-    : m_llvm_function_name (""),
-      m_function (nullptr),
-      m_argument_types (ov_args.length ())
+      : m_tr_eval (tr_eval), m_llvm_function_name (""), m_function (nullptr),
+        m_argument_types (ov_args.length ())
   {
     size_t nargs = ov_args.length ();
     for (size_t i = 0; i < nargs; ++i)
@@ -2539,10 +2619,10 @@
           }
 
         jit_factory& factory = conv.get_factory ();
-        jit_convert_llvm to_llvm;
-        raw_fn = to_llvm.convert_function (*this, infer.get_blocks (),
-                                           factory.constants (), fcn,
-                                           m_argument_types);
+        jit_convert_llvm to_llvm (*this);
+        raw_fn = to_llvm.convert_function (infer.get_blocks (),
+                                           factory.constants (),
+                                           fcn, m_argument_types);
 
         if (Vdebug_jit)
           {
@@ -2563,7 +2643,7 @@
 
         llvm::Value *wrapper_arg = wrapper.argument (builder, 0);
         std::vector<llvm::Value *> raw_args (nargs);
-        for (size_t i = 0; i < nargs; ++i)
+        for (unsigned i = 0; i < nargs; ++i)
           {
             llvm::Value *arg;
             // LLVM <= 3.6
@@ -2576,10 +2656,10 @@
 
             jit_type *arg_type = m_argument_types[i];
             const jit_function& cast = jit_typeinfo::cast (arg_type, any_t);
-            raw_args[i] = cast.call (builder, arg);
+            raw_args[i] = cast.call (*this, builder, arg);
           }
 
-        llvm::Value *result = raw_fn.call (builder, raw_args);
+        llvm::Value *result = raw_fn.call (*this, builder, raw_args);
         if (raw_fn.result ())
           {
             jit_type *raw_result_t = raw_fn.result ();
@@ -2682,26 +2762,29 @@
     return true;
   }
 
-
   // -------------------- jit_info --------------------
-  jit_info::jit_info (tree& tee)
-    : m_llvm_function_name (tree_jit::generate_unique_function_name ()),
-      m_function (nullptr)
+  jit_info::jit_info (tree_evaluator& tr_eval, tree& tee)
+      : m_tr_eval (tr_eval),
+        m_llvm_function_name (tree_jit::generate_unique_function_name ()),
+        m_function (nullptr)
   {
     compile (tee);
   }
 
-  jit_info::jit_info (tree& tee, const octave_value& for_bounds)
-    : m_llvm_function_name (tree_jit::generate_unique_function_name ()),
-      m_function (nullptr)
+  jit_info::jit_info (tree_evaluator& tr_eval, tree& tee,
+                      const octave_value& for_bounds)
+      : m_tr_eval (tr_eval),
+        m_llvm_function_name (tree_jit::generate_unique_function_name ()),
+        m_function (nullptr)
   {
     compile (tee, jit_typeinfo::type_of (for_bounds));
   }
 
-  jit_info::jit_info (tree_simple_for_command& tee,
+  jit_info::jit_info (tree_evaluator& tr_eval, tree_simple_for_command& tee,
                       const octave_value& for_bounds)
-    : m_llvm_function_name (tree_jit::generate_unique_forloop_name ()),
-      m_function (nullptr)
+      : m_tr_eval (tr_eval),
+        m_llvm_function_name (tree_jit::generate_unique_forloop_name ()),
+        m_function (nullptr)
   {
     compile (tee, jit_typeinfo::type_of (for_bounds));
   }
@@ -2709,7 +2792,7 @@
   bool
   jit_info::execute (const vmap& extra_vars) const
   {
-    if (! m_function)
+    if (!m_function)
       return false;
 
     std::vector<octave_base_value *> real_arguments (m_arguments.size ());
@@ -2728,15 +2811,13 @@
 
     m_function (&real_arguments[0]);
 
-    symbol_scope scope = __require_current_scope__ ("jit_info::execute");
-
     for (size_t i = 0; i < m_arguments.size (); ++i)
       {
         const std::string& name = m_arguments[i].first;
 
         // do not store for loop bounds temporary
-        if (name.size () && name[0] != '#')
-          scope.assign (m_arguments[i].first, real_arguments[i]);
+        if (! name.empty () && name[0] != '#')
+          m_tr_eval.assign (m_arguments[i].first, real_arguments[i]);
       }
 
     octave_quit ();
@@ -2750,14 +2831,14 @@
     if (! m_function)
       return true;
 
-    for (size_t i = 0; i < m_bounds.size (); ++i)
+    for (const type_bound_vector::value_type& bound : m_bounds)
       {
-        const std::string& arg_name = m_bounds[i].second;
+        const std::string& arg_name = bound.second;
         octave_value value = find (extra_vars, arg_name);
         jit_type *type = jit_typeinfo::type_of (value);
 
         // FIXME: Check for a parent relationship
-        if (type != m_bounds[i].first)
+        if (type != bound.first)
           return false;
       }
 
@@ -2767,7 +2848,7 @@
   void
   jit_info::compile (tree& tee, jit_type *for_bounds)
   {
-    llvm::Function * llvm_function = nullptr;
+    llvm::Function *llvm_function = nullptr;
 
     try
       {
@@ -2787,12 +2868,14 @@
           }
 
         jit_factory& factory = conv.get_factory ();
-        jit_convert_llvm to_llvm;
-
-        llvm_function = to_llvm.convert_loop (*this, infer.get_blocks (),
+        jit_convert_llvm to_llvm (*this);
+
+        llvm_function = to_llvm.convert_loop (infer.get_blocks (),
                                               factory.constants (),
                                               m_llvm_function_name);
 
+        // llvm_function->print(llvm::outs());
+
         m_arguments = to_llvm.get_arguments ();
 
         m_bounds = conv.get_bounds ();
@@ -2829,8 +2912,10 @@
 
         finalizeObject ();
 
+        //        jit_typeinfo::print_all_flocs();
+        //        print_all_flocs ();
+
         uint64_t void_fn = getFunctionAddress (m_llvm_function_name);
-
         if (void_fn == 0)
           {
             llvm_function->eraseFromParent ();
@@ -2851,9 +2936,7 @@
 
     if (iter == extra_vars.end ())
       {
-        symbol_scope scope = __require_current_scope__ ("jit_convert::find");
-
-        return scope.varval (vname);
+        return m_tr_eval.varval (vname);
       }
     else
       return *iter->second;
